<template>
    <div>
        <div v-if="!isLoading">
            <div v-if="Object.keys(currentOrder).length > 0">
                <div class="breadcrumbs">
                    <router-link to="/main">{{$t('message.main')}}</router-link>
                    <div class="circle"></div>
                    <router-link to="/orders">{{$t('message.departure_in_ukraine')}}</router-link>
                    <div class="circle"></div>
                    <div>{{$t('message.departure_in_ukraine_order')}} {{currentOrder.ew_number}}</div>
                </div>

                <div class="order_inside_title">
                    <div class="page-title">{{$t('message.departure_in_ukraine_order')}} {{currentOrder.ew_number}}
                    </div>
                </div>

                <div class="from_to_wrapper">
                    <div class="left_from_to_block">
                        <div class="from_to_title">
                            {{$t('message.from')}}
                        </div>
                        <div class="from_to_info_wrapper">
                            <div class="from_to_info_item" v-if="isIncomingB2C">
                                <div class="from_to_info_item_title">
                                    {{$t('message.company_name')}}
                                </div>
                                <div>
                                    <span>{{ currentOrder.sender_company }}</span>
                                </div>
                            </div>
                            <div class="from_to_info_item" v-else>
                                <div class="from_to_info_item_title">
                                    {{$t('message.full_name')}}
                                </div>
                                <div>
                                    <span>{{currentOrder.sender_last_name}}</span>
                                    <span>{{currentOrder.sender_first_name}}</span>
                                    <span>{{currentOrder.sender_second_name}}</span>
                                </div>
                            </div>

                            <div class="from_to_info_item">
                                <div class="from_to_info_item_title">
                                    {{$t('message.phone')}}
                                </div>
                                <div class="icon-link-holder">
                                    <span v-if="isIncomingB2C">
                                        <phone-icon />
                                        {{ $t('message.not_available') }}
                                    </span>
                                    <a :href="`tel:${currentOrder.sender_phone}`" v-else>
                                        <phone-icon />
                                        {{currentOrder.sender_phone}}
                                    </a>
                                </div>
                            </div>

                            <div class="from_to_info_item">
                                <div class="from_to_info_item_title">
                                    {{$t('message.sity')}}
                                </div>
                                <span>{{currentOrder.sender_department_city_ua}}</span>
                            </div>

                            <div class="from_to_info_item">
                                <div class="from_to_info_item_title">
                                    {{$t('message.department_capitalize')}}
                                </div>
                                <span>{{ senderDepartment }}</span>
                            </div>
                        </div>
                    </div>
                    <div class="right_from_to_block">
                        <div class="from_to_title">
                            {{$t('message.to')}}
                        </div>
                        <div class="from_to_info_wrapper">
                            <div class="from_to_info_item" v-if="isOutcomingC2B">
                                <div class="from_to_info_item_title">
                                    {{$t('message.company_name')}}
                                </div>
                                <div>
                                    <span>{{ currentOrder.receiver_company }}</span>
                                </div>
                            </div>
                            <div class="from_to_info_item" v-else>
                                <div class="from_to_info_item_title">
                                    {{$t('message.full_name')}}
                                </div>
                                <span>{{currentOrder.receiver_last_name}}</span>
                                <span>{{currentOrder.receiver_first_name}}</span>
                                <span>{{currentOrder.receiver_second_name}}</span>
                            </div>

                            <div class="from_to_info_item">
                                <div class="from_to_info_item_title">
                                    {{$t('message.phone')}}
                                </div>

                                <div class="icon-link-holder">
                                    <span v-if="isOutcomingC2B">
                                        <phone-icon />
                                        {{ $t('message.not_available') }}
                                    </span>
                                    <a :href="`tel:${currentOrder.receiver_phone}`" v-else>
                                        <phone-icon />
                                        {{currentOrder.receiver_phone}}
                                    </a>
                                </div>
                            </div>

                            <div class="from_to_info_item">
                                <div class="from_to_info_item_title">
                                    {{$t('message.sity')}}
                                </div>
                                <span>{{currentOrder.receiver_department_city_ua}}</span>
                            </div>

                            <div class="from_to_info_item">
                                <div class="from_to_info_item_title">
                                    {{$t('message.department_capitalize')}}
                                </div>
                                <span>{{ receiverDepartment }}</span>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="order_info_block">
                    <div class="from_to_title">
                        {{$t('message.order_information')}}
                    </div>
                    <div class="order_inside_info_wrapper">
                        <div class="order_table_text_wrapper">
                            <div class="order_info_table">
                                <div class="order_info_table_item">
                                    <div class="order_info_table_item_title">
                                        {{$t('message.cargo_count')}}
                                    </div>
                                    <div class="order_info_table_item_value">
                                        {{currentOrder.count_cargo_places}}
                                    </div>
                                </div>
                                <div class="order_info_table_item">
                                    <div class="order_info_table_item_title">
                                        {{$t('message.maximum_length')}}
                                    </div>
                                    <div class="order_info_table_item_value">
                                        {{currentOrder.max_size}} см.
                                    </div>
                                </div>
                                <div class="order_info_table_item">
                                    <div class="order_info_table_item_title">
                                        {{$t('message.weight')}}
                                    </div>
                                    <div class="order_info_table_item_value">
                                        {{currentOrder.weight}} кг.
                                    </div>
                                </div>
                                <div class="order_info_table_item">
                                    <div class="order_info_table_item_title">
                                        {{$t('message.declared_cost')}}
                                    </div>
                                    <div class="order_info_table_item_value">
                                        {{currentOrder.declared_cost}} {{$t('message.short_money_prefix')}}.
                                    </div>
                                </div>
                            </div>
                            <div class="order_info_text">
                                <div class="order_info_text_title">
                                    {{$t('message.description')}}
                                </div>
                                <div class="order_info_text_block">
                                    {{currentOrder.description}}
                                </div>
                            </div>
                        </div>


                        <!--Этот блок появляется только тогда, когда есть наложю платёж-->
                        <div class="warning_block_label" v-if="currentOrder.cod_is_available === '1'">
                            <p>{{$t('message.payback_warning')}}</p>
                            <div class="measure">{{currentOrder.declared_cost}} {{$t('message.short_money_prefix')}}
                            </div>
                        </div>
                        <!---->
                    </div>
                </div>


                <div class="order_payment_info">
                    <div class="order_payment_info_title">
                        {{$t('message.order_payment_information')}}
                    </div>
                    <div class="order_payment_table">
                        <div class="order_payment_table_left">
                            <!--  1 -->
                            <div class="order_payment_table_left_item">
                                <div class="order_payment_table_item_title">
                                    {{$t('message.delivery')}}:
                                </div>
                                <div class="order_payment_status_value_wrapper">
                                    <div class="order_payment_table_item_value">
                                        <span v-if="currentOrder.delivery_type !== 'B2C'" :class="{'my-payment': isMyDeliveryPayment}">
                                            {{currentOrder.delivery_payment}} {{$t('message.short_money_prefix')}}
                                        </span>
                                    </div>
                                    <div class="order_payment_table_item_status"
                                         v-if="currentOrder.delivery_payment > 0"
                                         :class="{ active: currentOrder.delivery_payment_status === 1 }">
                                        {{ currentOrder.delivery_payment_status === 1 ? $t('message.paid') : $t('message.not_paid') }}
                                    </div>
                                </div>
                                <div class="order_payment_table_item_personality" v-if="currentOrder.delivery_payment > 0">
                                    {{ currentOrder.delivery_payment_payer === 1 ? $t('message.pay_receiver') : $t('message.pay_sender') }}
                                </div>
                            </div>
                            <!--  1 -->

                            <!--  2 -->
                            <div class="order_payment_table_left_item">
                                <div class="order_payment_table_item_title">
                                    {{$t('message.payback')}}:
                                </div>
                                <div class="order_payment_status_value_wrapper">
                                    <div class="order_payment_table_item_value">
                                    <span v-if="currentOrder.delivery_type !== 'B2C'" :class="{'my-payment': isMyCodPayment}">
                                        {{ currentOrder.cod_sum }} {{$t('message.short_money_prefix')}}
                                    </span>
                                    </div>
                                    <div class="order_payment_table_item_status"
                                         :class="{ active: currentOrder.cod_payment_status === 1 }"
                                         v-if="currentOrder.cod_sum > 0"
                                    >
                                        {{ currentOrder.cod_payment_status === 1 ? $t('message.paid') : $t('message.not_paid') }}
                                    </div>
                                </div>
                                <div class="order_payment_table_item_personality" v-if="currentOrder.cod_sum > 0">
                                    {{ currentOrder.cod_commission_external_payer === 1 ? $t('message.pay_receiver') : $t('message.pay_sender') }}
                                </div>
                            </div>
                            <!--  2 -->

                            <!--  3 -->
                            <div class="order_payment_table_left_item" v-if="currentOrder.cod_commission_external > 0 && currentOrder.cod_is_available === 1">
                                <div class="order_payment_table_item_title">
                                    {{$t('message.service_cost')}}:
                                </div>
                                <div class="order_payment_status_value_wrapper">
                                    <div class="order_payment_table_item_value">
                                        <span :class="{'my-payment': isMyCodPayment}">
                                            {{ currentOrder.cod_commission_external }} {{$t('message.short_money_prefix')}}
                                        </span>
                                    </div>
                                    <div class="order_payment_table_item_status"
                                         :class="{ active: currentOrder.cod_commission_payment_status === 1 }"
                                    >
                                        {{ currentOrder.cod_payment_status === 1 ? $t('message.paid') : $t('message.not_paid') }}
                                    </div>
                                </div>
                                <div class="order_payment_table_item_personality">
                                    {{ currentOrder.cod_commission_external_payer === 1 ? $t('message.pay_receiver') : $t('message.pay_sender') }}
                                </div>
                            </div>
                            <!--  3 -->
                        </div>

                        <div class="order_payment_table_right">
                            <div class="order_payment_table_right_item" v-if="currentOrder.delivery_type !== 'B2C'">
                                <div class="order_payment_table_item_title">
                                    {{$t('message.sender_pay')}}:
                                </div>
                                <div class="order_payment_general" :class="{'my-payment': currentOrder.is_incoming === 0}">
                                    {{ currentOrder.cost_pay_sender }}
                                    {{$t('message.short_money_prefix')}}
                                </div>
                            </div>

                            <div class="order_payment_table_right_item">
                                <div class="order_payment_table_item_title">
                                    {{$t('message.recipient_pay')}}:
                                </div>
                                <div class="order_payment_general" :class="{'my-payment': currentOrder.is_incoming === 1}">
                                    {{ currentOrder.cost_pay_receiver }}
                                    {{$t('message.short_money_prefix')}}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="order_controls_block">
                    <a @click="$router.go(-1)" class="back_arrow_order">
                        <div class="icon"><img src="/img/back_arrow_grey.svg"></div>
                        <div class="words">{{$t('message.back')}}</div>
                    </a>
                </div>
            </div>
            <div v-else style="height: 100%">
                <div class="page_not_found">
                    <div class="message">
                        <div class="message-title">{{$t('message.page_not_found_ups')}}</div>
                        <div class="text">{{$t('message.page_not_found')}}</div>
                        <router-link to="/main" class="button">{{$t('message.to_main')}}</router-link>
                    </div>
                    <page_not_found_svg></page_not_found_svg>
                </div>
                <popup_main_menu></popup_main_menu>
            </div>
        </div>
        <div v-else class="animation-container">
            <lottie :options="defaultOptions" :height="150" :width="150"/>
        </div>
    </div>
</template>

<script>
    import VueTheMask from 'vue-the-mask';
    import CitiesInput from "./DeliveryCalculator/CitiesInput";
    import DepartmentInput from "./DeliveryCalculator/DepartmentInput";
    import LogoSquares from '../components/svg/LogoSquares';
    import PopupMainMenu from "../components/PopupMainMenu";
    import PageNotFoundSvg from './svg/PageNotFoundSvg';
    // import PackageCreateSuccess from "./Package/PackageCreateSuccess";

    import Printer from "./svg/Printer";
    import Download from "./svg/Download";
    import Duplicate from "./svg/Duplicate";
    import Phone from "./svg/Phone";
    import * as animationData from "./animation/preload";
    import Lottie from 'vue-lottie';

    Vue.use(VueTheMask);

    export default {
        components: {
            "cities-input": CitiesInput,
            "department-input": DepartmentInput,
            // "package-create-success": PackageCreateSuccess,
            "phone-icon": Phone,
            "printer": Printer,
            "download": Download,
            "duplicate": Duplicate,
            "logo-squares": LogoSquares,
            "popup_main_menu": PopupMainMenu,
            "page_not_found_svg": PageNotFoundSvg,
            'lottie': Lottie
        },
        data: () => ({
            to_surname: '',
            to_name: '',
            to_middle_name: '',
            to_city: {},
            to_city_name: '',
            from_city: {},
            from_city_name: '',
            to_department_no: '',
            to_phone: '',
            to_departments: {},
            from_surname: '',
            from_name: '',
            from_middle_name: '',
            // from_city: '',
            from_department_no: '',
            from_phone: '',
            from_departments: {},
            payer: 'sender',
            pay_way: 'card',
            card_number: '',
            get_payback: false,
            description: '',
            max_size: 0,
            weight: 0,
            errors: {},
            delivery_amount: 0,
            must_calculate: true,
            declared_cost: 0,
            package_count: 1,
            places_list: false,
            payback_select: false,
            rules: {
                float: v => parseFloat(v) == v || 'float only',
            },
            places: [
                {place_name: 'Oб`єкт 1'}
            ],
            isLoading: true,
            defaultOptions: {animationData: animationData.default},
            animationSpeed: 1,
            currentOrder: {}
        }),
        computed: {
            from_city_uuid: function () {
                return this.from_city.uuid;
            },
            to_city_uuid: function () {
                return this.to_city.uuid;
            },
            package_created: function () {
                return this.$store.state.package_created;
            },
            user: function () {
                return this.$store.getters.user;
            },
            count_cargo_places: {
                get() {
                    // this.places.pop();
                    return this.package_count;
                },
                set(n_v) {
                    if (this.package_count > n_v && this.package_count > 1) {
                        this.places.pop();
                    } else if (this.package_count < n_v) {
                        this.places.push({place_name: 'Об`єкт ' + n_v});
                    }
                    return this.package_count = n_v ? n_v : 1;
                }
            },
            senderDepartment() {
                let department = '№ ' + this.currentOrder.sender_department_number;
                department += ' (' + this.currentOrder.sender_department_address_ua + ')';
                return department;
            },
            receiverDepartment() {
                let department = '№ ' + this.currentOrder.receiver_department_number;
                department += ' (' + this.currentOrder.receiver_department_address_ua + ')';
                return department;
            },
            isIncomingB2C(){
                return this.currentOrder.delivery_type === 'B2C' && this.currentOrder.is_incoming === 1;
            },
            isOutcomingC2B() {
                return this.currentOrder.delivery_type === 'C2B' && this.currentOrder.is_incoming === 0;
            },
            isMyDeliveryPayment() {
                return (this.currentOrder.is_incoming === 1 && this.currentOrder.delivery_payment_payer === 1) ||
                    (this.currentOrder.is_incoming === 0 && this.currentOrder.delivery_payment_payer === 0);
            },
            isMyCodPayment() {
                return (this.currentOrder.is_incoming === 1 && this.currentOrder.cod_commission_external_payer === 1) ||
                    (this.currentOrder.is_incoming === 0 && this.currentOrder.cod_commission_external_payer === 0);
            }
        },
        watch: {
            user: function () {
                if (this.user.user && this.user.profile) {
                    this.from_surname = this.user.profile.second_name;
                    this.from_name = this.user.user.name;
                    this.from_middle_name = this.user.profile.middle_name;
                }
            }
        },
        methods: {
            async calculate() {
                const {data} = await axios.get('/api/calculate', {
                    params: {
                        declaredAmount: this.declared_cost,
                        weight: this.weight,
                        cityFrom: this.from_sity_uuid,
                        cityTo: this.to_sity_uuid
                    }
                });
                this.delivery_amount = data.delivery_amount;
                this.must_calculate = false;
                // var shippingPrice = data.deliverySum - this.declared_cost;
                // this.shippingPrice = shippingPrice;
            },
            createPackage() {
                let date_obj = new Date;
                let month = (date_obj.getMonth() >= 10) ? date_obj.getMonth() : ('0' + date_obj.getMonth());
                let date = (date_obj.getDate() >= 10) ? date_obj.getDate() : ('0' + date_obj.getDate());

                let date_str = date_obj.getUTCFullYear() + month + date;

                this.$store.dispatch('createOrder', {
                    number: "201907441",
                    date: date_str,
                    sender_city_id: this.from_city_uuid,
                    sender_company: [this.from_surname, this.from_name, this.from_middle_name].join(' '),
                    sender_contact: [this.from_surname, this.from_name, this.from_middle_name].join(' '),
                    sender_phone: this.from_phone,
                    sender_pick_up_address: this.from_department_no,
                    pick_up_is_required: false,
                    sender_branch: this.from_department_no,
                    receiver: [this.to_surname, this.to_name, this.to_middle_name].join(' '),
                    receiver_contact: this.to_phone,
                    receiver_phone: this.to_phone,
                    count_cargo_places: this.count_cargo_places,
                    branch: this.to_department_no,
                    max_size: this.max_size,
                    volume: '',
                    weight: this.weight,
                    delivery_type: 1,
                    cod_transfer_type: 1,
                    cod_card_number: this.card_number,
                    declared_cost: this.declared_cost,
                    delivery_amount: 0,
                    redelivery_amount: 0,
                    order_amount: this.declared_cost,
                    redelivery_payment_is_required: true, // const for c2c (always equivalent to delivery_is_required)
                    redelivery_payment_payer: 1, // const for c2c
                    delivery_payment_is_required: true, // const for c2c
                    add_description: this.description,
                    delivery_payment_payer: this.payer,
                    order_payment_is_required: true, // const
                    delivery_is_required: false,
                });
            },
            placesListTrigger() {
                if (this.places_list == true) {
                    this.places_list = false;
                } else {
                    this.places_list = true;
                }
            },
            paybackSelelectTrigger() {
                if (this.payback_select == true) {
                    this.payback_select = false;
                    this.get_payback = false;
                } else {
                    this.payback_select = true;
                    this.get_payback = true;
                }
            },
            async getOrder() {
                try {
                    const filters = {
                        filters: {
                            ew_number: this.$route.params.ew_number
                        },
                        sorting: {
                            date: 'DESC'
                        }
                    };
                    const {data} = await axios.post('/order/list', filters);
                    this.currentOrder = data.status ? data.result.ews[0] : {};
                    // console.log(this.currentOrder)
                } catch (e) {}
                this.isLoading = false;
            }
        },
        created() {
            this.$store.dispatch('set_profile');
            this.$store.dispatch('setStatuses', {});
            // получение информации о посылке
            this.getOrder();
        }
    }
</script>
